/*******************************************************************************
* File Name: AnalogFilter_1_INT.c
* Version 1.30
*
*  Description:
*    This file contains the code that operates during the ADC_SAR interrupt
*    service routine.
*
*   Note:
*
********************************************************************************
* Copyright 2015-2016, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include "AnalogFilter_1.h"
#include "cyapicallbacks.h"

/******************************************************************************
* Custom Declarations and Variables
* - add user include files, prototypes and variables between the following
*   #START and #END tags
******************************************************************************/
/* `#START AnalogFilter_1_SYS_VAR`  */

/* `#END`  */

#if(AnalogFilter_1_IRQ_REMOVE == 0u)


    /******************************************************************************
    * Function Name: AnalogFilter_1_ISR
    *******************************************************************************
    *
    * \brief Handle Interrupt Service Routine.
    *
    * \param None
    *
    * \return None
    *
    * \sideeffect None
    *
    ******************************************************************************/
    CY_ISR( AnalogFilter_1_ISR )
    {
        uint32 intr_status;

        /* Read interrupt status register */
        intr_status = AnalogFilter_1_SAR_INTR_REG;
        
        /* ISR Macro Callback */
        #ifdef AnalogFilter_1_ISR_CALLBACK
			AnalogFilter_1_ISR_Callback();
		#endif

        /************************************************************************
        *  Custom Code
        *  - add user ISR code between the following #START and #END tags
        *************************************************************************/
        /* `#START MAIN_AnalogFilter_1_ISR`  */

        /* `#END`  */

        /* Clear handled interrupt */
        AnalogFilter_1_SAR_INTR_REG = intr_status;
    }

#endif   /* End AnalogFilter_1_IRQ_REMOVE */


/* [] END OF FILE */
