/*******************************************************************************
* File Name: AnalogFilter_1_filterVinMux.h
* Version 1.80
*
*  Description:
*    This file contains the constants and function prototypes for the Analog
*    Multiplexer User Module AMux.
*
*   Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_AMUX_AnalogFilter_1_filterVinMux_H)
#define CY_AMUX_AnalogFilter_1_filterVinMux_H

#include "cyfitter.h"
#include "cyfitter_cfg.h"

#if ((CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC3) || \
         (CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC4) || \
         (CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC5))    
    #include "cytypes.h"
#else
    #include "syslib/cy_syslib.h"
#endif /* ((CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC3) */


/***************************************
*        Function Prototypes
***************************************/

void AnalogFilter_1_filterVinMux_Start(void) ;
#define AnalogFilter_1_filterVinMux_Init() AnalogFilter_1_filterVinMux_Start()
void AnalogFilter_1_filterVinMux_FastSelect(uint8 channel) ;
/* The Stop, Select, Connect, Disconnect and DisconnectAll functions are declared elsewhere */
/* void AnalogFilter_1_filterVinMux_Stop(void); */
/* void AnalogFilter_1_filterVinMux_Select(uint8 channel); */
/* void AnalogFilter_1_filterVinMux_Connect(uint8 channel); */
/* void AnalogFilter_1_filterVinMux_Disconnect(uint8 channel); */
/* void AnalogFilter_1_filterVinMux_DisconnectAll(void) */


/***************************************
*         Parameter Constants
***************************************/

#define AnalogFilter_1_filterVinMux_CHANNELS  4u
#define AnalogFilter_1_filterVinMux_MUXTYPE   1
#define AnalogFilter_1_filterVinMux_ATMOSTONE 0

/***************************************
*             API Constants
***************************************/

#define AnalogFilter_1_filterVinMux_NULL_CHANNEL 0xFFu
#define AnalogFilter_1_filterVinMux_MUX_SINGLE   1
#define AnalogFilter_1_filterVinMux_MUX_DIFF     2


/***************************************
*        Conditional Functions
***************************************/

#if AnalogFilter_1_filterVinMux_MUXTYPE == AnalogFilter_1_filterVinMux_MUX_SINGLE
# if !AnalogFilter_1_filterVinMux_ATMOSTONE
#  define AnalogFilter_1_filterVinMux_Connect(channel) AnalogFilter_1_filterVinMux_Set(channel)
# endif
# define AnalogFilter_1_filterVinMux_Disconnect(channel) AnalogFilter_1_filterVinMux_Unset(channel)
#else
# if !AnalogFilter_1_filterVinMux_ATMOSTONE
void AnalogFilter_1_filterVinMux_Connect(uint8 channel) ;
# endif
void AnalogFilter_1_filterVinMux_Disconnect(uint8 channel) ;
#endif

#if AnalogFilter_1_filterVinMux_ATMOSTONE
# define AnalogFilter_1_filterVinMux_Stop() AnalogFilter_1_filterVinMux_DisconnectAll()
# define AnalogFilter_1_filterVinMux_Select(channel) AnalogFilter_1_filterVinMux_FastSelect(channel)
void AnalogFilter_1_filterVinMux_DisconnectAll(void) ;
#else
# define AnalogFilter_1_filterVinMux_Stop() AnalogFilter_1_filterVinMux_Start()
void AnalogFilter_1_filterVinMux_Select(uint8 channel) ;
# define AnalogFilter_1_filterVinMux_DisconnectAll() AnalogFilter_1_filterVinMux_Start()
#endif

#endif /* CY_AMUX_AnalogFilter_1_filterVinMux_H */


/* [] END OF FILE */
