/*******************************************************************************
* File Name: AnalogFilter_1_intSarClock.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_AnalogFilter_1_intSarClock_H)
#define CY_CLOCK_AnalogFilter_1_intSarClock_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void AnalogFilter_1_intSarClock_StartEx(uint32 alignClkDiv);
#define AnalogFilter_1_intSarClock_Start() \
    AnalogFilter_1_intSarClock_StartEx(AnalogFilter_1_intSarClock__PA_DIV_ID)

#else

void AnalogFilter_1_intSarClock_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void AnalogFilter_1_intSarClock_Stop(void);

void AnalogFilter_1_intSarClock_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 AnalogFilter_1_intSarClock_GetDividerRegister(void);
uint8  AnalogFilter_1_intSarClock_GetFractionalDividerRegister(void);

#define AnalogFilter_1_intSarClock_Enable()                         AnalogFilter_1_intSarClock_Start()
#define AnalogFilter_1_intSarClock_Disable()                        AnalogFilter_1_intSarClock_Stop()
#define AnalogFilter_1_intSarClock_SetDividerRegister(clkDivider, reset)  \
    AnalogFilter_1_intSarClock_SetFractionalDividerRegister((clkDivider), 0u)
#define AnalogFilter_1_intSarClock_SetDivider(clkDivider)           AnalogFilter_1_intSarClock_SetDividerRegister((clkDivider), 1u)
#define AnalogFilter_1_intSarClock_SetDividerValue(clkDivider)      AnalogFilter_1_intSarClock_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define AnalogFilter_1_intSarClock_DIV_ID     AnalogFilter_1_intSarClock__DIV_ID

#define AnalogFilter_1_intSarClock_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define AnalogFilter_1_intSarClock_CTRL_REG   (*(reg32 *)AnalogFilter_1_intSarClock__CTRL_REGISTER)
#define AnalogFilter_1_intSarClock_DIV_REG    (*(reg32 *)AnalogFilter_1_intSarClock__DIV_REGISTER)

#define AnalogFilter_1_intSarClock_CMD_DIV_SHIFT          (0u)
#define AnalogFilter_1_intSarClock_CMD_PA_DIV_SHIFT       (8u)
#define AnalogFilter_1_intSarClock_CMD_DISABLE_SHIFT      (30u)
#define AnalogFilter_1_intSarClock_CMD_ENABLE_SHIFT       (31u)

#define AnalogFilter_1_intSarClock_CMD_DISABLE_MASK       ((uint32)((uint32)1u << AnalogFilter_1_intSarClock_CMD_DISABLE_SHIFT))
#define AnalogFilter_1_intSarClock_CMD_ENABLE_MASK        ((uint32)((uint32)1u << AnalogFilter_1_intSarClock_CMD_ENABLE_SHIFT))

#define AnalogFilter_1_intSarClock_DIV_FRAC_MASK  (0x000000F8u)
#define AnalogFilter_1_intSarClock_DIV_FRAC_SHIFT (3u)
#define AnalogFilter_1_intSarClock_DIV_INT_MASK   (0xFFFFFF00u)
#define AnalogFilter_1_intSarClock_DIV_INT_SHIFT  (8u)

#else 

#define AnalogFilter_1_intSarClock_DIV_REG        (*(reg32 *)AnalogFilter_1_intSarClock__REGISTER)
#define AnalogFilter_1_intSarClock_ENABLE_REG     AnalogFilter_1_intSarClock_DIV_REG
#define AnalogFilter_1_intSarClock_DIV_FRAC_MASK  AnalogFilter_1_intSarClock__FRAC_MASK
#define AnalogFilter_1_intSarClock_DIV_FRAC_SHIFT (16u)
#define AnalogFilter_1_intSarClock_DIV_INT_MASK   AnalogFilter_1_intSarClock__DIVIDER_MASK
#define AnalogFilter_1_intSarClock_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_AnalogFilter_1_intSarClock_H) */

/* [] END OF FILE */
