/*******************************************************************************
* File Name: FiltIn.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_FiltIn_ALIASES_H) /* Pins FiltIn_ALIASES_H */
#define CY_PINS_FiltIn_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"


/***************************************
*              Constants        
***************************************/
#define FiltIn_0			(FiltIn__0__PC)
#define FiltIn_0_PS		(FiltIn__0__PS)
#define FiltIn_0_PC		(FiltIn__0__PC)
#define FiltIn_0_DR		(FiltIn__0__DR)
#define FiltIn_0_SHIFT	(FiltIn__0__SHIFT)
#define FiltIn_0_INTR	((uint16)((uint16)0x0003u << (FiltIn__0__SHIFT*2u)))

#define FiltIn_INTR_ALL	 ((uint16)(FiltIn_0_INTR))


#endif /* End Pins FiltIn_ALIASES_H */


/* [] END OF FILE */
