/*******************************************************************************
* File Name: Filter_1_AMux.h
* Version 1.80
*
*  Description:
*    This file contains the constants and function prototypes for the Analog
*    Multiplexer User Module AMux.
*
*   Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_AMUX_Filter_1_AMux_H)
#define CY_AMUX_Filter_1_AMux_H

#include "cyfitter.h"
#include "cyfitter_cfg.h"

#if ((CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC3) || \
         (CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC4) || \
         (CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC5))    
    #include "cytypes.h"
#else
    #include "syslib/cy_syslib.h"
#endif /* ((CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC3) */


/***************************************
*        Function Prototypes
***************************************/

void Filter_1_AMux_Start(void) ;
#define Filter_1_AMux_Init() Filter_1_AMux_Start()
void Filter_1_AMux_FastSelect(uint8 channel) ;
/* The Stop, Select, Connect, Disconnect and DisconnectAll functions are declared elsewhere */
/* void Filter_1_AMux_Stop(void); */
/* void Filter_1_AMux_Select(uint8 channel); */
/* void Filter_1_AMux_Connect(uint8 channel); */
/* void Filter_1_AMux_Disconnect(uint8 channel); */
/* void Filter_1_AMux_DisconnectAll(void) */


/***************************************
*         Parameter Constants
***************************************/

#define Filter_1_AMux_CHANNELS  2u
#define Filter_1_AMux_MUXTYPE   1
#define Filter_1_AMux_ATMOSTONE 1

/***************************************
*             API Constants
***************************************/

#define Filter_1_AMux_NULL_CHANNEL 0xFFu
#define Filter_1_AMux_MUX_SINGLE   1
#define Filter_1_AMux_MUX_DIFF     2


/***************************************
*        Conditional Functions
***************************************/

#if Filter_1_AMux_MUXTYPE == Filter_1_AMux_MUX_SINGLE
# if !Filter_1_AMux_ATMOSTONE
#  define Filter_1_AMux_Connect(channel) Filter_1_AMux_Set(channel)
# endif
# define Filter_1_AMux_Disconnect(channel) Filter_1_AMux_Unset(channel)
#else
# if !Filter_1_AMux_ATMOSTONE
void Filter_1_AMux_Connect(uint8 channel) ;
# endif
void Filter_1_AMux_Disconnect(uint8 channel) ;
#endif

#if Filter_1_AMux_ATMOSTONE
# define Filter_1_AMux_Stop() Filter_1_AMux_DisconnectAll()
# define Filter_1_AMux_Select(channel) Filter_1_AMux_FastSelect(channel)
void Filter_1_AMux_DisconnectAll(void) ;
#else
# define Filter_1_AMux_Stop() Filter_1_AMux_Start()
void Filter_1_AMux_Select(uint8 channel) ;
# define Filter_1_AMux_DisconnectAll() Filter_1_AMux_Start()
#endif

#endif /* CY_AMUX_Filter_1_AMux_H */


/* [] END OF FILE */
