/*!*****************************************************************************
* \file Filter_1_UABH_B_param.h
* \version 1.30
*
* \brief 
*   Definitions from Component Parameter
*
********************************************************************************
* \copyright
* (c) 2014-2018, Cypress Semiconductor Corporation. All rights reserved.
* This software, including source code, documentation and related
* materials ("Software"), is owned by Cypress Semiconductor
* Corporation ("Cypress") and is protected by and subject to worldwide
* patent protection (United States and foreign), United States copyright
* laws and international treaty provisions. Therefore, you may use this
* Software only as provided in the license agreement accompanying the
* software package from which you obtained this Software ("EULA").
* If no EULA applies, Cypress hereby grants you a personal, nonexclusive,
* non-transferable license to copy, modify, and compile the
* Software source code solely for use in connection with Cypress's
* integrated circuit products. Any reproduction, modification, translation,
* compilation, or representation of this Software except as specified
* above is prohibited without the express written permission of Cypress.
* Disclaimer: THIS SOFTWARE IS PROVIDED AS-IS, WITH NO
* WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING,
* BUT NOT LIMITED TO, NONINFRINGEMENT, IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
* PARTICULAR PURPOSE. Cypress reserves the right to make
* changes to the Software without notice. Cypress does not assume any
* liability arising out of the application or use of the Software or any
* product or circuit described in the Software. Cypress does not
* authorize its products for use in any products where a malfunction or
* failure of the Cypress product may reasonably be expected to result in
* significant property damage, injury or death ("High Risk Product"). By
* including Cypress's product in a High Risk Product, the manufacturer
* of such system or application assumes all risk of such use and in doing
* so agrees to indemnify Cypress against all liability.
*******************************************************************************/

/* excluding defs in this file with cond and endcond */
/*! @cond */

#if !defined(Filter_1_UABH_B_PARAM_H)
#define Filter_1_UABH_B_PARAM_H

#include "Filter_1_UABH_B_CyUAB_types.h"
#include "Filter_1_UABH_B_regs.h"
#include "cytypes.h"
#include "cyfitter.h"

#define Filter_1_UABH_B_Nonzero(x) ( (x) != 0 )

#define Filter_1_UABH_B_UnmappedIsZero(x)  ((uint32)(((x)==-1)? 0 : (x)))

/*!
* \addtogroup group_init
* @{
*/
/*! Component Parameters set in the component customizer */
#define Filter_1_UABH_B_PARAM_COMP_MASK        1
#define Filter_1_UABH_B_PARAM_VDAC_EMPTY_MASK  0

#define Filter_1_UABH_B_NONZERO_INTR_MASK (Filter_1_UABH_B_Nonzero( \
    ( 1 |0) ))
#define Filter_1_UABH_B_DEFAULT_INTR_MASK ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_COMP_MASK)<<Filter_1_UABH_B_INTR_COMP_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_VDAC_EMPTY_MASK)<<Filter_1_UABH_B_INTR_VDAC_EMPTY_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_UAB_PWR        2
#define Filter_1_UABH_B_PARAM_BULK_SEL       0
#define Filter_1_UABH_B_PARAM_AGND_PTS       0
#define Filter_1_UABH_B_PARAM_AGND_PWR       0
#define Filter_1_UABH_B_PARAM_REF_PTS        0
#define Filter_1_UABH_B_PARAM_REF_PWR        7
#define Filter_1_UABH_B_PARAM_CMP_DSI_LEVEL  1
#define Filter_1_UABH_B_PARAM_CMP_EDGE       3
#define Filter_1_UABH_B_PARAM_CMP_PWR        7
#define Filter_1_UABH_B_PARAM_OA_PWR         7

#define Filter_1_UABH_B_PARAM_AGND_TIED      1
#define Filter_1_UABH_B_PARAM_REF_TIED       0

/*
#define Filter_1_UABH_B_NONZERO_OA_CTRL (Filter_1_UABH_B_Nonzero( \
    (2|0|0|0|\
    7||1|3|7|7) ))
*/

/* force inclusion in _initPairs */
#define Filter_1_UABH_B_NONZERO_OA_CTRL (Filter_1_UABH_B_Nonzero(1))

/*Shared switches agnd_tied and ref_tied occupy the same bit position, so ommitting from DEFAULT_OA_CTRL -
handled in Init() */
#define Filter_1_UABH_B_DEFAULT_OA_CTRL ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_UAB_PWR)<<Filter_1_UABH_B_UAB_PWR_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_BULK_SEL)<<Filter_1_UABH_B_BULK_SEL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_AGND_PTS)<<Filter_1_UABH_B_AGND_PTS_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_AGND_PWR)<<Filter_1_UABH_B_AGND_PWR_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_REF_PTS)<<Filter_1_UABH_B_REF_PTS_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_REF_PWR)<<Filter_1_UABH_B_REF_PWR_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CMP_DSI_LEVEL)<<Filter_1_UABH_B_CMP_DSI_LEVEL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CMP_EDGE)<<Filter_1_UABH_B_CMP_EDGE_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CMP_PWR)<<Filter_1_UABH_B_CMP_PWR_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_OA_PWR)<<Filter_1_UABH_B_OA_PWR_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_CB_GND       0
#define Filter_1_UABH_B_PARAM_CC_GND       0
#define Filter_1_UABH_B_PARAM_FRC_SIGN_BIT 0
#define Filter_1_UABH_B_PARAM_DAC_MODE_EN  0
#define Filter_1_UABH_B_PARAM_DAC_MODE     0

#define Filter_1_UABH_B_NONZERO_CAP_CTRL ( Filter_1_UABH_B_Nonzero( \
    (0|0|0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_CAP_CTRL ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_CB_GND)<<Filter_1_UABH_B_CB_GND_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CC_GND)<<Filter_1_UABH_B_CC_GND_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_FRC_SIGN_BIT)<<Filter_1_UABH_B_FRC_SIGN_BIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_DAC_MODE_EN)<<Filter_1_UABH_B_DAC_MODE_EN_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_DAC_MODE)<<Filter_1_UABH_B_DAC_MODE_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_CB_VAL    0
#define Filter_1_UABH_B_PARAM_CA_VAL    0
#define Filter_1_UABH_B_PARAM_SIGN_VAL  0
#define Filter_1_UABH_B_PARAM_CB_64     0
#define Filter_1_UABH_B_PARAM_CC_VAL    0
#define Filter_1_UABH_B_PARAM_CF_VAL    0

#define Filter_1_UABH_B_NONZERO_CAP_ABCF_VAL  (Filter_1_UABH_B_Nonzero( \
    (0|0|0|0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_CAP_ABCF_VAL  ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_CB_VAL)<<Filter_1_UABH_B_CB_VAL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CA_VAL)<<Filter_1_UABH_B_CA_VAL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SIGN_VAL)<<Filter_1_UABH_B_SIGN_VAL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CB_64)<<Filter_1_UABH_B_CB_64_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CC_VAL)<<Filter_1_UABH_B_CC_VAL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CF_VAL)<<Filter_1_UABH_B_CF_VAL_SHIFT) \
))

#define Filter_1_UABH_B_NONZERO_CAP_AB_VAL_NXT (Filter_1_UABH_B_Nonzero( \
    (0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_CAP_AB_VAL_NXT  ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_CB_VAL)<<Filter_1_UABH_B_CB_VAL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CA_VAL)<<Filter_1_UABH_B_CA_VAL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SIGN_VAL)<<Filter_1_UABH_B_SIGN_VAL_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_CC_VAL_UPDATE  0
#define Filter_1_UABH_B_PARAM_CF_VAL_UPDATE  0

#define Filter_1_UABH_B_NONZERO_CAP_CF_VAL_NXT (Filter_1_UABH_B_Nonzero( \
    (0|0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_CAP_CF_VAL_NXT ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_CC_VAL)<<Filter_1_UABH_B_CC_VAL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CF_VAL)<<Filter_1_UABH_B_CF_VAL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CC_VAL_UPDATE)<<Filter_1_UABH_B_CC_VAL_UPDATE_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CF_VAL_UPDATE)<<Filter_1_UABH_B_CF_VAL_UPDATE_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_SW_GX0        CyUAB_SwIsClosed( 0 )
#define Filter_1_UABH_B_PARAM_SW_GX1        CyUAB_SwIsClosed( 0 )
#define Filter_1_UABH_B_PARAM_SW_GX2        CyUAB_SwIsClosed( 0 )
#define Filter_1_UABH_B_PARAM_SW_GX3        CyUAB_SwIsClosed( 0 )
#define Filter_1_UABH_B_PARAM_SW_RG         CyUAB_SwIsClosed( 0  )
#define Filter_1_UABH_B_PARAM_SW_GG         CyUAB_SwIsClosed( 1  )
#define Filter_1_UABH_B_PARAM_SW_RT         CyUAB_SwIsClosed( 1  )
#define Filter_1_UABH_B_PARAM_SW_GT         CyUAB_SwIsClosed( 0  )
#define Filter_1_UABH_B_PARAM_SW_QT         CyUAB_SwIsClosed( 0  )
#define Filter_1_UABH_B_PARAM_EARLY_PS      0
#define Filter_1_UABH_B_PARAM_EARLY_PO      1

/*strobe source from cyfitter.h*/
#define Filter_1_UABH_B_PARAM_STRB_RST_SEL  (Filter_1_UABH_B_UnmappedIsZero(Filter_1_UABH_B_halfuab__STRB_RST_SEL))

#define Filter_1_UABH_B_PARAM_STRB_RST_EN   0


/*if switch parameter references a bad x input, ignored in initialization*/
#define Filter_1_UABH_B_XIN_OK(xin) ( (0UL==((uint32)(xin))) || (1UL==((uint32)(xin))) || (2UL==((uint32)(xin))) || (3UL==((uint32)(xin))) )
#define Filter_1_UABH_B_IGNORE_VAL 0UL      
#define Filter_1_UABH_B_XField(xin,val)  ( Filter_1_UABH_B_XIN_OK((xin)) ? ((uint32)(val)) : Filter_1_UABH_B_IGNORE_VAL )

/*
#define Filter_1_UABH_B_NONZERO_SW_STATIC (Filter_1_UABH_B_Nonzero( \
    (0|0|0|0|0|1|1|0|0|0|1|0|0) ))
*/

/* force inclusion in _initPairs */
#define Filter_1_UABH_B_NONZERO_SW_STATIC (Filter_1_UABH_B_Nonzero(1))

#define Filter_1_UABH_B_DEFAULT_SW_STATIC ((uint32)(\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X0,Filter_1_UABH_B_PARAM_SW_GX0<<Filter_1_UABH_B_StaticVShift(CyUAB_SW_GX0)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X1,Filter_1_UABH_B_PARAM_SW_GX1<<Filter_1_UABH_B_StaticVShift(CyUAB_SW_GX1)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X2,Filter_1_UABH_B_PARAM_SW_GX2<<Filter_1_UABH_B_StaticVShift(CyUAB_SW_GX2)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X3,Filter_1_UABH_B_PARAM_SW_GX3<<Filter_1_UABH_B_StaticVShift(CyUAB_SW_GX3)) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_RG)<<Filter_1_UABH_B_SW_RG_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_GG)<<Filter_1_UABH_B_SW_GG_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_RT)<<Filter_1_UABH_B_SW_RT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_GT)<<Filter_1_UABH_B_SW_GT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_QT)<<Filter_1_UABH_B_SW_QT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_EARLY_PS)<<Filter_1_UABH_B_EARLY_PS_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_EARLY_PO)<<Filter_1_UABH_B_EARLY_PO_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_STRB_RST_SEL)<<Filter_1_UABH_B_STRB_RST_SEL_SHIFT) | \
    (((uint32)Filter_1_UABH_B_PARAM_STRB_RST_EN)<<Filter_1_UABH_B_STRB_RST_EN_SHIFT) \
))

/*modbitab source from cyfitter.h*/
#define Filter_1_UABH_B_PARAM_MODBIT0_SRC_SEL   (Filter_1_UABH_B_UnmappedIsZero(Filter_1_UABH_B_halfuab__MODBIT0_SEL))
/*modbitc source from cyfitter.h*/
#define Filter_1_UABH_B_PARAM_MODBIT1_SRC_SEL   (Filter_1_UABH_B_UnmappedIsZero(Filter_1_UABH_B_halfuab__MODBIT1_SEL))

/*
#define Filter_1_UABH_B_NONZERO_SW_MODBIT_SRC (Filter_1_UABH_B_Nonzero( \
    (31|31) ))
*/
/* force inclusion in _initPairs */
#define Filter_1_UABH_B_NONZERO_SW_MODBIT_SRC (Filter_1_UABH_B_Nonzero(1))

#define Filter_1_UABH_B_DEFAULT_SW_MODBIT_SRC ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_MODBIT0_SRC_SEL)<<Filter_1_UABH_B_MODBIT0_SRC_SEL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_MODBIT1_SRC_SEL)<<Filter_1_UABH_B_MODBIT1_SRC_SEL_SHIFT) \
))


    
#define Filter_1_UABH_B_PARAM_SW_AX0_MODBIT  0
#define Filter_1_UABH_B_PARAM_SW_AX1_MODBIT  0
#define Filter_1_UABH_B_PARAM_SW_AX2_MODBIT  0
#define Filter_1_UABH_B_PARAM_SW_AX3_MODBIT  0
#define Filter_1_UABH_B_PARAM_SW_AP          0
#define Filter_1_UABH_B_PARAM_SW_AQ          0

#define Filter_1_UABH_B_NONZERO_SW_CA_IN0 (Filter_1_UABH_B_Nonzero( \
    (0|0|0|0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_SW_CA_IN0 ((uint32)(\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X0,Filter_1_UABH_B_PARAM_SW_AX0_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_AX0_MODBIT)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X1,Filter_1_UABH_B_PARAM_SW_AX1_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_AX1_MODBIT)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X2,Filter_1_UABH_B_PARAM_SW_AX2_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_AX2_MODBIT)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X3,Filter_1_UABH_B_PARAM_SW_AX3_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_AX3_MODBIT)) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_AP)<<Filter_1_UABH_B_SW_AP_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_AQ)<<Filter_1_UABH_B_SW_AQ_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_SW_AA         0
#define Filter_1_UABH_B_PARAM_SW_AR_MODBIT  0
#define Filter_1_UABH_B_PARAM_SW_AG_MODBIT  0
#define Filter_1_UABH_B_PARAM_SW_AV_MODBIT  0

/*Shared switch AA intentionally ommitted - handled in Init()*/
#define Filter_1_UABH_B_NONZERO_SW_CA_IN1 (Filter_1_UABH_B_Nonzero( \
    (0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_SW_CA_IN1 ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_SW_AR_MODBIT)<<Filter_1_UABH_B_SW_AR_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_AG_MODBIT)<<Filter_1_UABH_B_SW_AG_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_AV_MODBIT)<<Filter_1_UABH_B_SW_AV_MODBIT_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_SW_RA_MODBIT  0
#define Filter_1_UABH_B_PARAM_SW_GA_MODBIT  0
#define Filter_1_UABH_B_PARAM_SW_VA_MODBIT  0
#define Filter_1_UABH_B_PARAM_SW_SA         0

#define Filter_1_UABH_B_NONZERO_SW_CA_TOP (Filter_1_UABH_B_Nonzero( \
    (0|0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_SW_CA_TOP ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_SW_RA_MODBIT)<<Filter_1_UABH_B_SW_RA_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_GA_MODBIT)<<Filter_1_UABH_B_SW_GA_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_VA_MODBIT)<<Filter_1_UABH_B_SW_VA_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_SA)<<Filter_1_UABH_B_SW_SA_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_SW_BX0_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_BX1_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_BX2_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_BX3_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_BP         0
#define Filter_1_UABH_B_PARAM_SW_BQ         0

#define Filter_1_UABH_B_NONZERO_SW_CB_IN0 (Filter_1_UABH_B_Nonzero( \
    (0|0|0|0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_SW_CB_IN0 ((uint32)(\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X0,Filter_1_UABH_B_PARAM_SW_BX0_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_BX0_MODBIT)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X1,Filter_1_UABH_B_PARAM_SW_BX1_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_BX1_MODBIT)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X2,Filter_1_UABH_B_PARAM_SW_BX2_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_BX2_MODBIT)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X3,Filter_1_UABH_B_PARAM_SW_BX3_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_BX3_MODBIT)) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_BP)<<Filter_1_UABH_B_SW_BP_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_BQ)<<Filter_1_UABH_B_SW_BQ_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_SW_BB        0
#define Filter_1_UABH_B_PARAM_SW_BR_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_BG_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_BV_MODBIT 0

/*Shared switch BB intentionally ommitted - handled in Init()*/
#define Filter_1_UABH_B_NONZERO_SW_CB_IN1 (Filter_1_UABH_B_Nonzero( \
    (0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_SW_CB_IN1 ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_SW_BR_MODBIT)<<Filter_1_UABH_B_SW_BR_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_BG_MODBIT)<<Filter_1_UABH_B_SW_BG_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_BV_MODBIT)<<Filter_1_UABH_B_SW_BV_MODBIT_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_SW_RB_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_GB_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_VB_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_TB        0
#define Filter_1_UABH_B_PARAM_SW_SB        0

#define Filter_1_UABH_B_NONZERO_SW_CB_TOP (Filter_1_UABH_B_Nonzero( \
    (0|0|0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_SW_CB_TOP ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_SW_RB_MODBIT)<<Filter_1_UABH_B_SW_RB_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_GB_MODBIT)<<Filter_1_UABH_B_SW_GB_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_VB_MODBIT)<<Filter_1_UABH_B_SW_VB_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_TB)<<Filter_1_UABH_B_SW_TB_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_SB)<<Filter_1_UABH_B_SW_SB_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_SW_CX0_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_CX1_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_CX2_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_CX3_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_CP         0
#define Filter_1_UABH_B_PARAM_SW_CQ         0
    
#define Filter_1_UABH_B_NONZERO_SW_CC_IN0 (Filter_1_UABH_B_Nonzero( \
    (0|0|0|0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_SW_CC_IN0 ((uint32)(\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X0,Filter_1_UABH_B_PARAM_SW_CX0_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_CX0_MODBIT)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X1,Filter_1_UABH_B_PARAM_SW_CX1_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_CX1_MODBIT)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X2,Filter_1_UABH_B_PARAM_SW_CX2_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_CX2_MODBIT)) |\
    Filter_1_UABH_B_XField(Filter_1_UABH_B_X3,Filter_1_UABH_B_PARAM_SW_CX3_MODBIT<<Filter_1_UABH_B_DynamicVShift(CyUAB_SW_CX3_MODBIT)) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_CP)<<Filter_1_UABH_B_SW_CP_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_CQ)<<Filter_1_UABH_B_SW_CQ_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_SW_CC        0
#define Filter_1_UABH_B_PARAM_SW_CR_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_CG_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_CV_MODBIT 0

/*Shared switch CC intentionally ommitted - handled in Init()*/
#define Filter_1_UABH_B_NONZERO_SW_CC_IN1 (Filter_1_UABH_B_Nonzero( \
    (0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_SW_CC_IN1 ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_SW_CR_MODBIT)<<Filter_1_UABH_B_SW_CR_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_CG_MODBIT)<<Filter_1_UABH_B_SW_CG_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_CV_MODBIT)<<Filter_1_UABH_B_SW_CV_MODBIT_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_SW_RC_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_GC_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_VC_MODBIT 0
#define Filter_1_UABH_B_PARAM_SW_TC        0
#define Filter_1_UABH_B_PARAM_SW_SC        0
#define Filter_1_UABH_B_PARAM_SW_ZC        0

#define Filter_1_UABH_B_NONZERO_SW_CC_TOP (Filter_1_UABH_B_Nonzero( \
    (0|0|0|0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_SW_CC_TOP ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_SW_RC_MODBIT)<<Filter_1_UABH_B_SW_RC_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_GC_MODBIT)<<Filter_1_UABH_B_SW_GC_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_VC_MODBIT)<<Filter_1_UABH_B_SW_VC_MODBIT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_TC)<<Filter_1_UABH_B_SW_TC_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_SC)<<Filter_1_UABH_B_SW_SC_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_ZC)<<Filter_1_UABH_B_SW_ZC_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_SW_GF 0
#define Filter_1_UABH_B_PARAM_SW_PF 0
#define Filter_1_UABH_B_PARAM_SW_PS 0
#define Filter_1_UABH_B_PARAM_SW_PO 0

#define Filter_1_UABH_B_NONZERO_SW_CF_BOT (Filter_1_UABH_B_Nonzero( \
    (0|0|0|0) ))
#define Filter_1_UABH_B_DEFAULT_SW_CF_BOT ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_SW_GF)<<Filter_1_UABH_B_SW_GF_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_PF)<<Filter_1_UABH_B_SW_PF_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_PS)<<Filter_1_UABH_B_SW_PS_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SW_PO)<<Filter_1_UABH_B_SW_PO_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_CMP_FF     1
#define Filter_1_UABH_B_PARAM_VALID_WAVE 3
#define Filter_1_UABH_B_PARAM_TRIG_OUT   0
#define Filter_1_UABH_B_PARAM_STROBE_SW  15
#define Filter_1_UABH_B_PARAM_STROBE_RST 0

#define Filter_1_UABH_B_NONZERO_SW_OTHER (Filter_1_UABH_B_Nonzero( \
    (1|3|0|15|0) ))
#define Filter_1_UABH_B_DEFAULT_SW_OTHER ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_CMP_FF)<<Filter_1_UABH_B_CMP_FF_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_VALID_WAVE)<<Filter_1_UABH_B_VALID_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_TRIG_OUT)<<Filter_1_UABH_B_TRIG_OUT_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_STROBE_SW)<<Filter_1_UABH_B_STROBE_SW_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_STROBE_RST)<<Filter_1_UABH_B_STROBE_RST_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_CA_BOOST  1
#define Filter_1_UABH_B_PARAM_CB_BOOST  1
#define Filter_1_UABH_B_PARAM_CC_BOOST  1
#define Filter_1_UABH_B_PARAM_CF_BOOST  1
#define Filter_1_UABH_B_PARAM_SUM_BOOST 1
#define Filter_1_UABH_B_PARAM_PUMP_WAVE 1
    
#define Filter_1_UABH_B_NONZERO_SW_BOOST_CTRL (Filter_1_UABH_B_Nonzero( \
    (1|1|1|1|1|1) ))
#define Filter_1_UABH_B_DEFAULT_SW_BOOST_CTRL ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_CA_BOOST)<<Filter_1_UABH_B_CA_BOOST_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CB_BOOST)<<Filter_1_UABH_B_CB_BOOST_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CC_BOOST)<<Filter_1_UABH_B_CC_BOOST_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_CF_BOOST)<<Filter_1_UABH_B_CF_BOOST_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SUM_BOOST)<<Filter_1_UABH_B_SUM_BOOST_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_PUMP_WAVE)<<Filter_1_UABH_B_PUMP_WAVE_SHIFT) \
))
#define Filter_1_UABH_B_PARAM_RC_RES_SEL       1
#define Filter_1_UABH_B_PARAM_RC_CAP_SEL       1
   
#define Filter_1_UABH_B_NONZERO_RC_CTRL    (Filter_1_UABH_B_Nonzero( \
	(1|1) ))
#define Filter_1_UABH_B_DEFAULT_RC_CTRL ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_RC_RES_SEL)<<Filter_1_UABH_B_RC_RES_SEL_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_RC_CAP_SEL)<<Filter_1_UABH_B_RC_CAP_SEL_SHIFT) \
))
    
#define Filter_1_UABH_B_PARAM_STARTUP_DELAY 0
#define Filter_1_UABH_B_PARAM_ALIGN_MODE    0

#define Filter_1_UABH_B_NONZERO_STARTUP_DELAY (Filter_1_UABH_B_Nonzero( \
	(0|0) ))
#define Filter_1_UABH_B_DEFAULT_STARTUP_DELAY ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_STARTUP_DELAY)<<Filter_1_UABH_B_STARTUP_DELAY_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_ALIGN_MODE)<<Filter_1_UABH_B_ALIGN_MODE_SHIFT) \
))

#define Filter_1_UABH_B_PARAM_SUBSAMPLE 0    
#define Filter_1_UABH_B_PARAM_SUBSAMPLE_INIT 0    
    
#define Filter_1_UABH_B_NONZERO_SUBSAMPLE_CTRL (Filter_1_UABH_B_Nonzero( \
    (0|0) ))
#define Filter_1_UABH_B_DEFAULT_SUBSAMPLE_CTRL ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_SUBSAMPLE)<<Filter_1_UABH_B_SUBSAMPLE_SHIFT) |\
    (((uint32)Filter_1_UABH_B_PARAM_SUBSAMPLE_INIT)<<Filter_1_UABH_B_SUBSAMPLE_INIT_SHIFT) \
))
    
#define Filter_1_UABH_B_PARAM_LAST_STEP  3

/*trigger_in source from cyfitter.h*/
#define Filter_1_UABH_B_PARAM_TRIG_SEL    (Filter_1_UABH_B_UnmappedIsZero(Filter_1_UABH_B_halfuab__TRIG_SEL))

#define Filter_1_UABH_B_PARAM_TRIGGER_EN 1

/*
#define Filter_1_UABH_B_NONZERO_SRAM_CTRL (Filter_1_UABH_B_Nonzero( \
    (3|31|1) ))
*/
/* force inclusion in _initPairs */
#define Filter_1_UABH_B_NONZERO_SRAM_CTRL (Filter_1_UABH_B_Nonzero(1))    
 
#define Filter_1_UABH_B_DEFAULT_SRAM_CTRL ((uint32)(\
    (((uint32)Filter_1_UABH_B_PARAM_LAST_STEP)<<Filter_1_UABH_B_LAST_STEP_SHIFT) | \
    (((uint32)Filter_1_UABH_B_PARAM_TRIG_SEL)<<Filter_1_UABH_B_TRIG_SEL_SHIFT)   | \
    (((uint32)Filter_1_UABH_B_PARAM_TRIGGER_EN)<<Filter_1_UABH_B_TRIGGER_EN_SHIFT) \
))
/*There is intentionally no run bit symbol parameter and the run bit is not set as part of the Init() function*/

#define Filter_1_UABH_B_PARAM_WAVE_STEP_0  3601
#define Filter_1_UABH_B_PARAM_WAVE_STEP_1  3601
#define Filter_1_UABH_B_PARAM_WAVE_STEP_2  2834
#define Filter_1_UABH_B_PARAM_WAVE_STEP_3  2838
#define Filter_1_UABH_B_PARAM_WAVE_STEP_4  0
#define Filter_1_UABH_B_PARAM_WAVE_STEP_5  0
#define Filter_1_UABH_B_PARAM_WAVE_STEP_6  0
#define Filter_1_UABH_B_PARAM_WAVE_STEP_7  0
#define Filter_1_UABH_B_PARAM_WAVE_STEP_8  0
#define Filter_1_UABH_B_PARAM_WAVE_STEP_9  0
#define Filter_1_UABH_B_PARAM_WAVE_STEP_10 0
#define Filter_1_UABH_B_PARAM_WAVE_STEP_11 0
#define Filter_1_UABH_B_PARAM_WAVE_STEP_12 0
#define Filter_1_UABH_B_PARAM_WAVE_STEP_13 0
#define Filter_1_UABH_B_PARAM_WAVE_STEP_14 0
#define Filter_1_UABH_B_PARAM_WAVE_STEP_15 0

#define Filter_1_UABH_B_NONZERO_WAVE_0  (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_0 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_1  (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_1 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_2  (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_2 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_3  (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_3 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_4  (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_4 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_5  (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_5 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_6  (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_6 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_7  (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_7 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_8  (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_8 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_9  (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_9 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_10 (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_10 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_11 (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_11 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_12 (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_12 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_13 (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_13 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_14 (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_14 ) )
#define Filter_1_UABH_B_NONZERO_WAVE_15 (Filter_1_UABH_B_Nonzero( Filter_1_UABH_B_PARAM_WAVE_STEP_15 ) )


/*all wave steps up to and including the last non-zero wave step 
    are included in the waveConfig array definition */
/*always include WAVE_STEP_0, since LAST_STEP minimum is 0*/
#define Filter_1_UABH_B_INC_STEP_0 (Filter_1_UABH_B_Nonzero(1))

#define Filter_1_UABH_B_INC_STEP_1  ( \
    Filter_1_UABH_B_NONZERO_WAVE_1  || \
    Filter_1_UABH_B_NONZERO_WAVE_2  || Filter_1_UABH_B_NONZERO_WAVE_3  || \
    Filter_1_UABH_B_NONZERO_WAVE_4  || Filter_1_UABH_B_NONZERO_WAVE_5  || \
    Filter_1_UABH_B_NONZERO_WAVE_6  || Filter_1_UABH_B_NONZERO_WAVE_7  || \
    Filter_1_UABH_B_NONZERO_WAVE_8  || Filter_1_UABH_B_NONZERO_WAVE_9  || \
    Filter_1_UABH_B_NONZERO_WAVE_10 || Filter_1_UABH_B_NONZERO_WAVE_11 || \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_2  ( \
    Filter_1_UABH_B_NONZERO_WAVE_2  || Filter_1_UABH_B_NONZERO_WAVE_3  || \
    Filter_1_UABH_B_NONZERO_WAVE_4  || Filter_1_UABH_B_NONZERO_WAVE_5  || \
    Filter_1_UABH_B_NONZERO_WAVE_6  || Filter_1_UABH_B_NONZERO_WAVE_7  || \
    Filter_1_UABH_B_NONZERO_WAVE_8  || Filter_1_UABH_B_NONZERO_WAVE_9  || \
    Filter_1_UABH_B_NONZERO_WAVE_10 || Filter_1_UABH_B_NONZERO_WAVE_11 || \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_3  ( \
    Filter_1_UABH_B_NONZERO_WAVE_3  || \
    Filter_1_UABH_B_NONZERO_WAVE_4  || Filter_1_UABH_B_NONZERO_WAVE_5  || \
    Filter_1_UABH_B_NONZERO_WAVE_6  || Filter_1_UABH_B_NONZERO_WAVE_7  || \
    Filter_1_UABH_B_NONZERO_WAVE_8  || Filter_1_UABH_B_NONZERO_WAVE_9  || \
    Filter_1_UABH_B_NONZERO_WAVE_10 || Filter_1_UABH_B_NONZERO_WAVE_11 || \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_4  ( \
    Filter_1_UABH_B_NONZERO_WAVE_4  || Filter_1_UABH_B_NONZERO_WAVE_5  || \
    Filter_1_UABH_B_NONZERO_WAVE_6  || Filter_1_UABH_B_NONZERO_WAVE_7  || \
    Filter_1_UABH_B_NONZERO_WAVE_8  || Filter_1_UABH_B_NONZERO_WAVE_9  || \
    Filter_1_UABH_B_NONZERO_WAVE_10 || Filter_1_UABH_B_NONZERO_WAVE_11 || \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )

#define Filter_1_UABH_B_INC_STEP_5  ( \
    Filter_1_UABH_B_NONZERO_WAVE_5  || \
    Filter_1_UABH_B_NONZERO_WAVE_6  || Filter_1_UABH_B_NONZERO_WAVE_7  || \
    Filter_1_UABH_B_NONZERO_WAVE_8  || Filter_1_UABH_B_NONZERO_WAVE_9  || \
    Filter_1_UABH_B_NONZERO_WAVE_10 || Filter_1_UABH_B_NONZERO_WAVE_11 || \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )

#define Filter_1_UABH_B_INC_STEP_6  ( \
    Filter_1_UABH_B_NONZERO_WAVE_6  || Filter_1_UABH_B_NONZERO_WAVE_7  || \
    Filter_1_UABH_B_NONZERO_WAVE_8  || Filter_1_UABH_B_NONZERO_WAVE_9  || \
    Filter_1_UABH_B_NONZERO_WAVE_10 || Filter_1_UABH_B_NONZERO_WAVE_11 || \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_7  ( \
    Filter_1_UABH_B_NONZERO_WAVE_7  || \
    Filter_1_UABH_B_NONZERO_WAVE_8  || Filter_1_UABH_B_NONZERO_WAVE_9  || \
    Filter_1_UABH_B_NONZERO_WAVE_10 || Filter_1_UABH_B_NONZERO_WAVE_11 || \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_8  ( \
    Filter_1_UABH_B_NONZERO_WAVE_8  || Filter_1_UABH_B_NONZERO_WAVE_9  || \
    Filter_1_UABH_B_NONZERO_WAVE_10 || Filter_1_UABH_B_NONZERO_WAVE_11 || \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_9  ( \
    Filter_1_UABH_B_NONZERO_WAVE_9  || \
    Filter_1_UABH_B_NONZERO_WAVE_10 || Filter_1_UABH_B_NONZERO_WAVE_11 || \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_10  ( \
    Filter_1_UABH_B_NONZERO_WAVE_10 || Filter_1_UABH_B_NONZERO_WAVE_11 || \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_11  ( \
    Filter_1_UABH_B_NONZERO_WAVE_11 || \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_12  ( \
    Filter_1_UABH_B_NONZERO_WAVE_12 || Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_13  ( \
    Filter_1_UABH_B_NONZERO_WAVE_13 || \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_14  ( \
    Filter_1_UABH_B_NONZERO_WAVE_14 || Filter_1_UABH_B_NONZERO_WAVE_15 )
    
#define Filter_1_UABH_B_INC_STEP_15  ( Filter_1_UABH_B_NONZERO_WAVE_15 )
    
    
/*! @} group_init */

#endif /* #ifndef Filter_1_UABH_B_PARAM_H */
    
/*! @endcond */

/* [] END OF FILE */
