/*******************************************************************************
* File Name: Filter_1_intUabClock.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_Filter_1_intUabClock_H)
#define CY_CLOCK_Filter_1_intUabClock_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void Filter_1_intUabClock_StartEx(uint32 alignClkDiv);
#define Filter_1_intUabClock_Start() \
    Filter_1_intUabClock_StartEx(Filter_1_intUabClock__PA_DIV_ID)

#else

void Filter_1_intUabClock_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void Filter_1_intUabClock_Stop(void);

void Filter_1_intUabClock_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 Filter_1_intUabClock_GetDividerRegister(void);
uint8  Filter_1_intUabClock_GetFractionalDividerRegister(void);

#define Filter_1_intUabClock_Enable()                         Filter_1_intUabClock_Start()
#define Filter_1_intUabClock_Disable()                        Filter_1_intUabClock_Stop()
#define Filter_1_intUabClock_SetDividerRegister(clkDivider, reset)  \
    Filter_1_intUabClock_SetFractionalDividerRegister((clkDivider), 0u)
#define Filter_1_intUabClock_SetDivider(clkDivider)           Filter_1_intUabClock_SetDividerRegister((clkDivider), 1u)
#define Filter_1_intUabClock_SetDividerValue(clkDivider)      Filter_1_intUabClock_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define Filter_1_intUabClock_DIV_ID     Filter_1_intUabClock__DIV_ID

#define Filter_1_intUabClock_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define Filter_1_intUabClock_CTRL_REG   (*(reg32 *)Filter_1_intUabClock__CTRL_REGISTER)
#define Filter_1_intUabClock_DIV_REG    (*(reg32 *)Filter_1_intUabClock__DIV_REGISTER)

#define Filter_1_intUabClock_CMD_DIV_SHIFT          (0u)
#define Filter_1_intUabClock_CMD_PA_DIV_SHIFT       (8u)
#define Filter_1_intUabClock_CMD_DISABLE_SHIFT      (30u)
#define Filter_1_intUabClock_CMD_ENABLE_SHIFT       (31u)

#define Filter_1_intUabClock_CMD_DISABLE_MASK       ((uint32)((uint32)1u << Filter_1_intUabClock_CMD_DISABLE_SHIFT))
#define Filter_1_intUabClock_CMD_ENABLE_MASK        ((uint32)((uint32)1u << Filter_1_intUabClock_CMD_ENABLE_SHIFT))

#define Filter_1_intUabClock_DIV_FRAC_MASK  (0x000000F8u)
#define Filter_1_intUabClock_DIV_FRAC_SHIFT (3u)
#define Filter_1_intUabClock_DIV_INT_MASK   (0xFFFFFF00u)
#define Filter_1_intUabClock_DIV_INT_SHIFT  (8u)

#else 

#define Filter_1_intUabClock_DIV_REG        (*(reg32 *)Filter_1_intUabClock__REGISTER)
#define Filter_1_intUabClock_ENABLE_REG     Filter_1_intUabClock_DIV_REG
#define Filter_1_intUabClock_DIV_FRAC_MASK  Filter_1_intUabClock__FRAC_MASK
#define Filter_1_intUabClock_DIV_FRAC_SHIFT (16u)
#define Filter_1_intUabClock_DIV_INT_MASK   Filter_1_intUabClock__DIVIDER_MASK
#define Filter_1_intUabClock_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_Filter_1_intUabClock_H) */

/* [] END OF FILE */
