/*******************************************************************************
* File Name: Pol.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Pol_ALIASES_H) /* Pins Pol_ALIASES_H */
#define CY_PINS_Pol_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"


/***************************************
*              Constants        
***************************************/
#define Pol_0			(Pol__0__PC)
#define Pol_0_PS		(Pol__0__PS)
#define Pol_0_PC		(Pol__0__PC)
#define Pol_0_DR		(Pol__0__DR)
#define Pol_0_SHIFT	(Pol__0__SHIFT)
#define Pol_0_INTR	((uint16)((uint16)0x0003u << (Pol__0__SHIFT*2u)))

#define Pol_INTR_ALL	 ((uint16)(Pol_0_INTR))


#endif /* End Pins Pol_ALIASES_H */


/* [] END OF FILE */
